#ifdef WIN32
#pragma warning (disable:4786)
#endif

#ifdef WIN32
#include <AudioDevices/Win32AudioDevice.h>
#else
#include <AudioDevices/OSSAudioDevice.h>
#endif

const int AudioDevice::SUCCESS = 1;
const int AudioDevice::FAILURE = 0;
const int AudioDevice::MAX_VOLUME = 100;
const int AudioDevice::DEFAULT_BLOCK_SIZE = 512;

DeviceCaps*
AudioDevice::getDevCaps()
{
#ifdef WIN32
    return Win32AudioDevice::getDevCaps();
#else 
    return OSSAudioDevice::getDevCaps();
#endif
}
