#ifndef DEVCAP_H_INCLUDED
#define DEVCAP_H_INCLUDED

#include <string>
#include <Common/AudioFormats.h>

using namespace std;

typedef int DevHandle;

// This class stores information about one audio device. It is used by
// DeviceCaps as the basic unit of information.
class DevCap
{
    public:

    static const int IN_DEV_CAP;
    static const int OUT_DEV_CAP;
    static const int NONE;

    DevCap();
    DevCap(const DevCap &right);
    ~DevCap();

    int devCapType;
    DevHandle devHandle;
    string *name;
    AudioFormats *audioFormats;
    int blockSize;
    bool inVolSupp, outVolSupp;

    protected:
    private:
};

#endif
