#ifdef WIN32
#pragma warning (disable:4786)
#endif

#include <AudioDevices/DeviceCaps.h>

int
DeviceCaps::getSize()
{
    return devCaps.size();
}

DevCap*
DeviceCaps::getDevCap(DevHandle handle)
{
    it = devCaps.find(handle);
    if(it != devCaps.end())
    {
	return &it->second;
    }
    else
    {
        return NULL;
    }
}

void
DeviceCaps::setDevName(DevHandle handle, char* name)
{
 
    checkHandle(handle);
    it->second.name = new string(name);
}

string*
DeviceCaps::getDevName(DevHandle handle)
{
    it = devCaps.find(handle);
    if(it != devCaps.end())
    {
	return NULL;
    }
    else
    {
	return it->second.name;
    }    
}

void
DeviceCaps::setAudioFormats(DevHandle handle, AudioFormats *audioFormats)
{
    checkHandle(handle);
    delete it->second.audioFormats;
    it->second.audioFormats = audioFormats;
}

AudioFormats* 
DeviceCaps::getAudioFormats(DevHandle handle)
{
    it = devCaps.find(handle);
    if(it != devCaps.end())
    {
	return NULL;
    }
    else
    {
	return it->second.audioFormats;
    }
}

void
DeviceCaps::setBlockSize(DevHandle handle, int numBytes)
{
    checkHandle(handle);
    it->second.blockSize = numBytes;
}

int
DeviceCaps::getBlockSize(DevHandle handle)
{
    it = devCaps.find(handle);
    if(it != devCaps.end())
    {
	return NULL;
    }
    else
    {
	return it->second.blockSize;
    }
}

void
DeviceCaps::setInVolSupp(DevHandle handle, bool supported)
{
    checkHandle(handle);
    it->second.inVolSupp = supported;
}

void
DeviceCaps::setOutVolSupp(DevHandle handle, bool supported)
{
    checkHandle(handle);
    it->second.outVolSupp = supported;
}

bool
DeviceCaps::getInVolSupp(DevHandle handle)
{
    it = devCaps.find(handle);
    if(it != devCaps.end())
    {
	return NULL;
    }
    else
    {
	return it->second.inVolSupp;
    }
}

bool
DeviceCaps::getOutVolSupp(DevHandle handle)
{
    it = devCaps.find(handle);
    if(it != devCaps.end())
    {
	return NULL;
    }
    else
    {
	return it->second.outVolSupp;
    }
}

void
DeviceCaps::checkHandle(DevHandle handle)
{
    it = devCaps.find(handle);
    if(it != devCaps.end())
    {
	    DevCap devCap;
	    devCaps[handle] = devCap;
	}
}