#ifdef WIN32
    #pragma warning (disable:4786) 
#endif

#include <AudioDevices/Win32DeviceCaps.h>

void
Win32DeviceCaps::setRecLine(DevHandle handle, DWORD recLine)
{
    checkHandle(handle,DevCap::IN_DEV_CAP);
    it->second.recLine = recLine;
}

DWORD
Win32DeviceCaps::getRecLine(DevHandle handle)
{
    it = win32DevCaps.find(handle);
    if(it != win32DevCaps.end())
    {
	return it->second.recLine;
    }
    else
    {
        return DevCap::NONE;
    }
}

void
Win32DeviceCaps::setWaveInDesc(DevHandle handle, UINT waveInDesc)
{
    checkHandle(handle);
    it->second.waveInDesc = waveInDesc;
}

void
Win32DeviceCaps::setWaveOutDesc(DevHandle handle, UINT waveOutDesc)
{
    checkHandle(handle);
    it->second.waveOutDesc = waveOutDesc;
}

UINT
Win32DeviceCaps::getWaveInDesc(DevHandle handle)
{
    it = win32DevCaps.find(handle);
    if(it != win32DevCaps.end())
    {
	return it->second.waveInDesc;
    }
    else
    {
        return DevCap::NONE;
    }
}

UINT
Win32DeviceCaps::getWaveOutDesc(DevHandle handle)
{
    it = win32DevCaps.find(handle);
    if(it != win32DevCaps.end())
    {
	return it->second.waveOutDesc;
    }
    else
    {
        return DevCap::NONE;
    }
}

void
Win32DeviceCaps::setMixerDesc(DevHandle handle, UINT mixerDesc)
{
    checkHandle(handle,DevCap::IN_DEV_CAP);
    it->second.mixerDesc = mixerDesc;
}

UINT
Win32DeviceCaps::getMixerDesc(DevHandle handle)
{
    it = win32DevCaps.find(handle);
    if(it != win32DevCaps.end())
    {
	return it->second.mixerDesc;
    }
    else
    {
        return DevCap::NONE;
    }
}

void
Win32DeviceCaps::checkHandle(DevHandle handle)
{
    it = win32DevCaps.find(handle);
    if(it != win32DevCaps.end())
    {
	    Win32DevCap win32DevCap;
	    win32DevCaps[handle] = win32DevCap;
	}
}