#ifndef WIN32DEVICECAPS_H_INCLUDED
#define WIN32DEVICECAPS_H_INCLUDED

#include <AudioDevices/DeviceCaps.h>
#include <AudioDevices/Win32DevCap.h>

// This class stores infomation about various Win32 devices. Its basic unit of
// storage is a Win32Dev class.
class Win32DeviceCaps : public DeviceCaps
{
    public:

    Win32DeviceCaps() {};
    ~Win32DeviceCaps() {};

    void setRecLine(DevHandle handle, DWORD recLine);
    DWORD getRecLine(DevHandle handle);

    void setWaveInDesc(DevHandle handle, UINT waveInDesc);
    UINT getWaveInDesc(DevHandle handle);

    void setWaveOutDesc(DevHandle handle, UINT waveOutDesc);
    UINT getWaveOutDesc(DevHandle handle);

    // The mixer is associated with the waveIn device because it is needed to
    // control the in volume.
    void setMixerDesc(DevHandle handle, UINT mixerDesc);
    UINT getMixerDesc(DevHandle handle);

    protected:

    private:

    void checkHandle(DevHandle devHandle);

    typedef map<DevHandle,Win32DevCap> DevCapsMap;
    void checkHandle(DevHandle devHandle, int type);
    DevCapsMap::iterator it; 
    DevCapsMap win32DevCaps;
};

#endif