#ifndef CODEC_H_INCLUDED_C56FFB2A
#define CODEC_H_INCLUDED_C56FFB2A

#include <list>

#include <util/factory_dll.h>
#include <Common/AudioFormat.h>
#include <Common/CodecFormat.h>

using namespace std;

template<class object> class dll_object_ref;

typedef list<CodecFormat> CodecFormatList;

class CodecState;

//##ModelId=3A9029530209
class Codec
{
public:
	virtual void encode(short *inbuf, unsigned char *outbuf, int &length) = 0;
	virtual void decode(unsigned char *inbuf, short *outbuf, int &length) = 0;
	virtual const CodecFormatList &getSupportedFormats() = 0;

	virtual setCodecFormat(CodecFormat &codecFormat){
		delete this->codecFormat;
		this->codecFormat = new CodecFormat(codecFormat);
	}

	Codec():codecFormat(NULL){}

	~Codec(){
		delete codecFormat;
	}
protected:
	CodecFormat *codecFormat;
	CodecState *codecState;
private:
	friend class dll_object_ref< Codec >;
	virtual void destroy() = 0;
};

#define CODEC_FACTORY_PREFIX codec_
#define CODEC_FACTORY_PREFIX_STR STRING( CODEC_FACTORY_PREFIX )
#define CODEC_FACTORY_ENTRY( class, alias ) FACTORYFUNC( Codec, class, codec_, alias)

#define STRING( x ) _STRING( x )
#define _STRING( x ) #x


#endif /* CODEC_H_INCLUDED_C56FFB2A */
