// RTPEvent.h: interface for the RTPEvent class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RTPEVENT_H__AAFE37ED_0E9B_4741_A014_1B7E3A5822D5__INCLUDED_)
#define AFX_RTPEVENT_H__AAFE37ED_0E9B_4741_A014_1B7E3A5822D5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "RTPCommon.h"

struct timeval;

//	Wraps the necessary information to process an RTP event in 
//	a convient class.

class RTPEvent  
{
public:
	//copy constructor
	RTPEvent( RTPEvent & right);
	//Default Constructor: initializes all members to 0
	RTPEvent();
	//Constructor
	//@param cid The RTP Session context id
	//@param opaque The RTP event data, stores pointer
	//@param tp Pointer to a timeval struct
	RTPEvent(int cid,rtp_opaque_t opaque, timeval *tp);
	//Destructor, does nothing.
	virtual ~RTPEvent();
	//Assignment Operator
	//Copies values from passed RTPEvent, does not allocate new memory
	//@param right Event to copy
	RTPEvent & operator =(const RTPEvent &right);

	//@return the time this event is to occur.
	inline double getTime(){return time;}
	//@return the opaque rtp data
	inline rtp_opaque_t getOpaque(){return opaque;}
	//@return The RTP Session context id this event is
	// associated with.
	inline context getContextID(){return cid;}

protected:
	//session context id
	context cid;
	//rtp event data
	rtp_opaque_t opaque;
	//event time
	double time;

};

#endif // !defined(AFX_RTPEVENT_H__AAFE37ED_0E9B_4741_A014_1B7E3A5822D5__INCLUDED_)
